Loading...
Searching...
No Matches
casacore::MCEarthMagnetic Class Reference
measures package (libcasa_measures) » Measures_module » Measures_module_internal_classes

More...

`#include <MCEarthMagnetic.h>`

## Public Member Functions

| MCEarthMagnetic ()
| Default constructor.
| ~MCEarthMagnetic ()
Public Member Functions inherited from casacore::MCBase
virtual | ~MCBase ()

## Static Public Member Functions

static String | showState ()
| Show the state of the conversion engine (mainly for debugging purposes).

## Private Types

enum

Routes {
GAL_J2000 ,
GAL_B1950 ,
J2000_GAL ,
B1950_GAL ,
J2000_B1950 ,
B1950_J2000 ,
J2000_JMEAN ,
B1950_BMEAN ,
JMEAN_J2000 ,
JMEAN_JTRUE ,
BMEAN_B1950 ,
BMEAN_BTRUE ,
JTRUE_JMEAN ,
BTRUE_BMEAN ,
J2000_JNAT ,
JNAT_J2000 ,
B1950_APP ,
APP_B1950 ,
APP_TOPO ,
HADEC_AZEL ,
HADEC_AZELGEO ,
AZEL_HADEC ,
AZELGEO_HADEC ,
HADEC_TOPO ,
AZEL_AZELSW ,
AZELGEO_AZELSWGEO ,
AZELSW_AZEL ,
AZELSWGEO_AZELGEO ,
APP_JNAT ,
JNAT_APP ,
J2000_ECLIP ,
ECLIP_J2000 ,
JMEAN_MECLIP ,
MECLIP_JMEAN ,
JTRUE_TECLIP ,
TECLIP_JTRUE ,
GAL_SUPERGAL ,
SUPERGAL_GAL ,
ITRF_HADEC ,
HADEC_ITRF ,
TOPO_HADEC ,
TOPO_APP ,
ICRS_J2000 ,
J2000_ICRS ,
N_Routes ,
R_MODEL0 ,
R_MODEL ,
R_IGRF
}

| The list of actual routines provided. More...

## Private Member Functions

| MCEarthMagnetic (const MCEarthMagnetic &other)
| Copy constructor (not implemented).
MCEarthMagnetic & | operator= (const MCEarthMagnetic &other)
| Assignment (not implemented).
virtual void | getConvert (MConvertBase &mc, const MRBase &inref, const MRBase &outref)
| Create conversion function pointer.
virtual void | initConvert (uInt which, MConvertBase &mc)
| Create help structures for Measure conversion routines.
virtual void | clearConvert ()
| Delete the pointers used in the MeasConvert help structure cache.
virtual void | doConvert (MeasValue &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Routines to convert EarthMagnetics from one reference frame to another.
void | doConvert (MVEarthMagnetic &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Conversion routine to cater for inheritance question.

## Static Private Member Functions

static void | doFillState ()
| Fill the global state.

## Private Attributes

MVPosition * | MVPOS1
EarthField * | EFIELD
MeasMath | measMath

## Static Private Attributes

static uInt | ToRef_p [N_Routes][3]
| Transition list.
static uInt | FromTo_p [MEarthMagnetic::N_Types][MEarthMagnetic::N_Types]
| Transition matrix.
static std::once_flag | theirInitOnceFlag
| Object to ensure safe multi-threaded lazy single initialization.

## Friends

class | MeasConvert< MEarthMagnetic >
| Conversion of data.

## Additional Inherited Members

Public Types inherited from casacore::MCBase
enum | Routes { N_Routes }
| Each derived class should have a list of routines to be called: More...
Static Protected Member Functions inherited from casacore::MCBase
static void | makeState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| The following routines create a state transition matrix from a list of all defined transitions.
static String | showState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| Return a fromatted String with matrix information (based on < 100 types).

## Detailed Description

MEarthMagnetic conversion routines

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMEarthMagnetic

### Prerequisite

- Measure class
- MCBase base class
- overall conversion class

### Etymology

Measure, Convert and EarthMagnetic

### Synopsis

Contains state machinery and caching for actual conversions

### Example

See Measures module description for conversion examples.

### Motivation

### To Do

- Use MCDirection routines directly

Definition at line 84 of file MCEarthMagnetic.h.

## Member Enumeration Documentation

## Routes

enum casacore::MCEarthMagnetic::Routes

private

The list of actual routines provided.

Warning: Each AA_BB in the list points to routine that can be used in the FromTo list in the getConvert routine; In addition the type to which each is converted should be in the ToRef array, again in the proper order;

Enumerator
GAL_J2000 |
GAL_B1950 |
J2000_GAL |
B1950_GAL |
J2000_B1950 |
B1950_J2000 |
J2000_JMEAN |
B1950_BMEAN |
JMEAN_J2000 |
JMEAN_JTRUE |
BMEAN_B1950 |
BMEAN_BTRUE |
JTRUE_JMEAN |
BTRUE_BMEAN |
J2000_JNAT |
JNAT_J2000 |
B1950_APP |
APP_B1950 |
APP_TOPO |
HADEC_AZEL |
HADEC_AZELGEO |
AZEL_HADEC |
AZELGEO_HADEC |
HADEC_TOPO |
AZEL_AZELSW |
AZELGEO_AZELSWGEO |
AZELSW_AZEL |
AZELSWGEO_AZELGEO |
APP_JNAT |
JNAT_APP |
J2000_ECLIP |
ECLIP_J2000 |
JMEAN_MECLIP |
MECLIP_JMEAN |
JTRUE_TECLIP |
TECLIP_JTRUE |
GAL_SUPERGAL |
SUPERGAL_GAL |
ITRF_HADEC |
HADEC_ITRF |
TOPO_HADEC |
TOPO_APP |
ICRS_J2000 |
J2000_ICRS |
N_Routes |
R_MODEL0 | General for Models.
R_MODEL |
R_IGRF | Individual models. Order should be the same as in MEarthMagnetic.h

Definition at line 110 of file MCEarthMagnetic.h.

## Constructor & Destructor Documentation

## MCEarthMagnetic() [1/2]

casacore::MCEarthMagnetic::MCEarthMagnetic | ( |  | ) |

Default constructor.

Referenced by MCEarthMagnetic(), MeasConvert< MEarthMagnetic >, and operator=().

## ~MCEarthMagnetic()

casacore::MCEarthMagnetic::~MCEarthMagnetic | ( |  | ) |

## MCEarthMagnetic() [2/2]

casacore::MCEarthMagnetic::MCEarthMagnetic | ( | const MCEarthMagnetic & | other | ) |

private

Copy constructor (not implemented).

References MCEarthMagnetic().

## Member Function Documentation

## clearConvert()

virtual void casacore::MCEarthMagnetic::clearConvert | ( |  | ) |

private virtual

Delete the pointers used in the MeasConvert help structure cache.

Implements casacore::MCBase.

## doConvert() [1/2]

virtual void casacore::MCEarthMagnetic::doConvert | ( | MeasValue & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private virtual

Routines to convert EarthMagnetics from one reference frame to another.

Implements casacore::MCBase.

## doConvert() [2/2]

void casacore::MCEarthMagnetic::doConvert | ( | MVEarthMagnetic & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private

Conversion routine to cater for inheritance question.

## doFillState()

void casacore::MCEarthMagnetic::doFillState | ( |  | ) |

static private

Fill the global state.

Called using theirInitOnce.

## getConvert()

virtual void casacore::MCEarthMagnetic::getConvert | ( | MConvertBase & | mc,
|  | const MRBase & | inref,
|  | const MRBase & | outref )

private virtual

Create conversion function pointer.

Implements casacore::MCBase.

## initConvert()

virtual void casacore::MCEarthMagnetic::initConvert | ( | uInt | which,
|  | MConvertBase & | mc )

private virtual

Create help structures for Measure conversion routines.

Implements casacore::MCBase.

## operator=()

MCEarthMagnetic & casacore::MCEarthMagnetic::operator= | ( | const MCEarthMagnetic & | other | ) |

private

Assignment (not implemented).

References MCEarthMagnetic().

## showState()

String casacore::MCEarthMagnetic::showState | ( |  | ) |

static

Show the state of the conversion engine (mainly for debugging purposes).

## Friends And Related Symbol Documentation

## MeasConvert< MEarthMagnetic >

friend class MeasConvert< MEarthMagnetic >

friend

Conversion of data.

Definition at line 1 of file MCEarthMagnetic.h.

References MCEarthMagnetic().

## Member Data Documentation

## EFIELD

EarthField* casacore::MCEarthMagnetic::EFIELD

private

Definition at line 173 of file MCEarthMagnetic.h.

## FromTo_p

uInt casacore::MCEarthMagnetic::FromTo_p[MEarthMagnetic::N_Types][MEarthMagnetic::N_Types]

static private

Transition matrix.

Definition at line 180 of file MCEarthMagnetic.h.

## measMath

MeasMath casacore::MCEarthMagnetic::measMath

private

Definition at line 174 of file MCEarthMagnetic.h.

## MVPOS1

MVPosition* casacore::MCEarthMagnetic::MVPOS1

private

Definition at line 172 of file MCEarthMagnetic.h.

## theirInitOnceFlag

std::once_flag casacore::MCEarthMagnetic::theirInitOnceFlag

static private

Object to ensure safe multi-threaded lazy single initialization.

Definition at line 182 of file MCEarthMagnetic.h.

## ToRef_p

uInt casacore::MCEarthMagnetic::ToRef_p[N_Routes][3]

static private

Transition list.

Definition at line 178 of file MCEarthMagnetic.h.

The documentation for this class was generated from the following file:

- measures/Measures/MCEarthMagnetic.h